//=================================================================
//
//  Simple RF powermeter
//
//  (c) Dietmar Krause, DL2SBA
//
//  License see https://creativecommons.org/licenses/by/4.0/
//
#include <avr/pgmspace.h>
#include <Nextion.h>
#include <PeakHold.h>

#include "data.h"

//  the display
Nextion nex(NEXTION_PORT, true);


//=================================================================
//
//  various stuff
char dtostrfBuffer[20];
char strBuffer[20];



//=================================================================
//
//    Data buffer
//
volatile uint16_t dataBuffer[DATA_BUFFER_SIZE_MAX];
volatile uint16_t dataBufferIndex;
volatile uint16_t currentBufferSize;

//=================================================================
//
//    Data maintained by ISR
//
volatile uint16_t isrActValue;
volatile uint16_t isrAvgValue;
volatile MaximumHold minHold = MaximumHold(T_PEAKHOLD_INIT, T_PEAKDECAY_INIT, 20);
volatile MinimumHold maxHold = MinimumHold(T_PEAKHOLD_INIT, T_PEAKDECAY_INIT, 20);


//=================================================================
//
//    peakhold data
//
volatile uint16_t   peakHoldCurrent;
volatile uint16_t   peakDecayCurrent;

//=================================================================
//
//    meter main mode
//
uint8_t mode     = MODE_RUN;
int8_t  powerOffset_dB;
int8_t  powerOffset_Index;
int8_t  powerSteps[9] = {0, -3, -6, -10, -20, -30, -40, -50, -60};

uint8_t  calFreqIdx     = CALFREQ_INIT;
uint16_t calFreqSteps[CALFREQ_NUM] = {50, 145, 433, 1000, 2000, 3000};

//=================================================================
//
//    meter fast sampling mode
//
uint8_t  fastMode = false;

//=================================================================
//
//
uint8_t  backlight;

//=================================================================
//
//  calibration data
//
//  k0              k1               k2              k3
const PROGMEM float kFactors[] = {
    2.80342581E+01, -3.40466467E-02, 5.36059447E-06, -9.64826574E-10,   //    50 MHZ
    2.81602896E+01, -3.43993780E-02, 5.36926411E-06, -9.35643168E-10,   //   145 MHZ
    2.73776126E+01, -3.35128770E-02, 4.76795974E-06, -8.13901646E-10,   //   433 MHz
    2.63845320E+01, -3.25466666E-02, 4.19419955E-06, -7.11984824E-10,   //  1000 MHz
    2.63845320E+01, -3.25466666E-02, 4.19419955E-06, -7.11984824E-10,   //  2000 MHz
    2.63845320E+01, -3.25466666E-02, 4.19419955E-06, -7.11984824E-10,   //  3000 MHz
};


