//=================================================================
//
//  Simple RF powermeter
//
//  (c) Dietmar Krause, DL2SBA
//
//  License see https://creativecommons.org/licenses/by/4.0/
//
#ifndef _DATA_H
#define _DATA_H

#define VERSION_TAG "V1.9.0  2018-04-22"
#define PORT_ISR    13
#define PORT_RUN    5

#define MEASUREMENT_FREQUENCY 100 // in Hz


#define MIN_LOSS4BARS -66

#define MAX_ADC 4096

#define NEXTION_PORT Serial

extern Nextion nex;

extern char dtostrfBuffer[];
extern char strBuffer[];

#define DATA_BUFFER_SIZE_MIN    10
#define DATA_BUFFER_SIZE_MAX    60
#define DATA_BUFFER_SIZE_INIT   30
#define DATA_BUFFER_SIZE_STEP   10
extern volatile uint16_t dataBuffer[];
extern volatile uint16_t dataBufferIndex;
extern volatile uint16_t currentBufferSize;

extern volatile uint16_t isrActValue;
extern volatile uint16_t isrAvgValue;
extern volatile MaximumHold minHold;
extern volatile MinimumHold maxHold;


#define T_PEAKHOLD_MIN  (MEASUREMENT_FREQUENCY / 2)
#define T_PEAKHOLD_INIT (MEASUREMENT_FREQUENCY )
#define T_PEAKHOLD_MAX  (MEASUREMENT_FREQUENCY * 3)
#define T_PEAKHOLD_STEP 10
extern volatile  uint16_t peakHoldCurrent;

#define T_PEAKDECAY_MIN  0
#define T_PEAKDECAY_INIT 20
#define T_PEAKDECAY_MAX  70
#define T_PEAKDECAY_STEP 5
extern volatile  uint16_t peakDecayCurrent;

#define MODE_RUN    1
#define MODE_SETUP  2
#define MODE_RAW    3
extern uint8_t  mode;

#define POWER_OFFSET_INIT   0
#define POWER_OFFSET_STEP   1
extern int8_t powerOffset_Index;
extern int8_t powerOffset_dB;
extern int8_t powerSteps[9];

#define CALFREQ_INIT    0
#define CALFREQ_MIN     0
#define CALFREQ_MAX     5
#define CALFREQ_NUM     6
extern uint8_t calFreqIdx;
extern uint16_t calFreqSteps[CALFREQ_NUM];


#define BACKLIGHT_MIN   10
#define BACKLIGHT_INIT  50
#define BACKLIGHT_MAX   100
#define BACKLIGHT_STEP  5
extern uint8_t  backlight;

extern uint8_t  fastMode;

extern const PROGMEM float kFactors[];

#endif

